Class for managing IEDriver specific options.

### Hierarchy

- Capabilities
  - Options

## Index

### Constructors

- constructor

### Methods

- [serialize]
- addArguments
- browserAttachTimeout
- delete
- enableElementCacheCleanup
- enablePersistentHover
- ensureCleanSession
- forceCreateProcessApi
- get
- getAcceptInsecureCerts
- getAlertBehavior
- getBrowserName
- getBrowserVersion
- getPageLoadStrategy
- getPlatform
- getProxy
- has
- ignoreZoomSetting
- initialBrowserUrl
- introduceFlakinessByIgnoringProtectedModeSettings
- keys
- merge
- requireWindowFocus
- set
- setAcceptInsecureCerts
- setAlertBehavior
- setBrowserName
- setBrowserVersion
- setExtractPath
- setHost
- setLogFile
- setLogLevel
- setLoggingPrefs
- setPageLoadStrategy
- setPlatform
- setProxy
- silent
- usePerProcessProxy
- chrome
- edge
- firefox
- ie
- safari

## Constructors

### constructor

- new Options(): <internal>.Options

- Overrides Capabilities.constructor

  #### Returns <internal>.Options

## Methods

### [serialize]

- [serialize](): {}

- Inherited from Capabilities.[serialize]

  suppress

    {checkTypes} Suppress [] access on a struct (state inherited from Map).

  #### Returns {}

  The JSON representation of this instance. Note, the returned object may contain nested promised values.

### addArguments

- addArguments(...var_args: string[]): <internal>.Options

- Specifies command-line switches to use when launching Internet Explorer. This is only valid when used with {@link #forceCreateProcessApi}.

  #### Parameters

  - ##### Rest ...var_args: string[]

    The arguments to add.

  #### Returns <internal>.Options

  A self reference.

### browserAttachTimeout

- browserAttachTimeout(timeout: number): <internal>.Options

- Configures the timeout, in milliseconds, that the driver will attempt to located and attach to a newly opened instance of Internet Explorer. The default is zero, which indicates waiting indefinitely.

  #### Parameters

  - ##### timeout: number

    How long to wait for IE.

  #### Returns <internal>.Options

  A self reference.

### delete

- delete(key: string): boolean

- Inherited from Capabilities.delete

  Deletes an entry from this set of capabilities.

  #### Parameters

  - ##### key: string

    the capability key to delete.

  #### Returns boolean

### enableElementCacheCleanup

- enableElementCacheCleanup(enable: boolean): <internal>.Options

- Configures whether the driver should attempt to remove obsolete {@linkplain webdriver.WebElement WebElements} from its internal cache on page navigation (true by default). Disabling this option will cause the driver to run with a larger memory footprint.

  #### Parameters

  - ##### enable: boolean

    Whether to enable element reference cleanup.

  #### Returns <internal>.Options

  A self reference.

### enablePersistentHover

- enablePersistentHover(enable: boolean): <internal>.Options

- Configures whether to enable persistent mouse hovering (true by default). Persistent hovering is achieved by continuously firing mouse over events at the last location the mouse cursor has been moved to.

  #### Parameters

  - ##### enable: boolean

    Whether to enable persistent hovering.

  #### Returns <internal>.Options

  A self reference.

### ensureCleanSession

- ensureCleanSession(cleanSession: boolean): <internal>.Options

- Configures whether to clear the cache, cookies, history, and saved form data before starting the browser. Using this capability will clear session data for all running instances of Internet Explorer, including those started manually.

  #### Parameters

  - ##### cleanSession: boolean

    Whether to clear all session data on startup.

  #### Returns <internal>.Options

  A self reference.

### forceCreateProcessApi

- forceCreateProcessApi(force: boolean): <internal>.Options

- Configures whether to launch Internet Explorer using the CreateProcess API. If this option is not specified, IE is launched using IELaunchURL, if available. For IE 8 and above, this option requires the TabProcGrowth registry value to be set to 0.

  #### Parameters

  - ##### force: boolean

    Whether to use the CreateProcess API.

  #### Returns <internal>.Options

  A self reference.

### get

- get(key: string): any

- Inherited from Capabilities.get

  #### Parameters

  - ##### key: string

    The capability to return.

  #### Returns any

  The capability with the given key, or {@code null} if it has not been set.

### getAcceptInsecureCerts

- getAcceptInsecureCerts(): boolean

- Inherited from Capabilities.getAcceptInsecureCerts

  #### Returns boolean

  whether the session is configured to accept insecure TLS certificates.

### getAlertBehavior

- getAlertBehavior(): string

- Inherited from Capabilities.getAlertBehavior

  #### Returns string

  the behavior pattern for responding to unhandled user prompts, or undefined if not set.

### getBrowserName

- getBrowserName(): string

- Inherited from Capabilities.getBrowserName

  #### Returns string

  the configured browser name, or undefined if not set.

### getBrowserVersion

- getBrowserVersion(): string

- Inherited from Capabilities.getBrowserVersion

  #### Returns string

  the configured browser version, or undefined if not set.

### getPageLoadStrategy

- getPageLoadStrategy(): string

- Inherited from Capabilities.getPageLoadStrategy

  Returns the configured page load strategy.

  #### Returns string

  the page load strategy.

### getPlatform

- getPlatform(): string

- Inherited from Capabilities.getPlatform

  #### Returns string

  the configured platform or undefined if not set.

### getProxy

- getProxy(): ProxyConfig

- Inherited from Capabilities.getProxy

  #### Returns ProxyConfig

  the configured proxy settings, or undefined if not set.

### has

- has(key: string): boolean

- Inherited from Capabilities.has

  #### Parameters

  - ##### key: string

    The capability to check.

  #### Returns boolean

  Whether the specified capability is set.

### ignoreZoomSetting

- ignoreZoomSetting(ignore: boolean): <internal>.Options

- Indicates whether to skip the check that the browser's zoom level is set to 100%.

  #### Parameters

  - ##### ignore: boolean

    Whether to ignore the browser's zoom level settings.

  #### Returns <internal>.Options

  A self reference.

### initialBrowserUrl

- initialBrowserUrl(url: string): <internal>.Options

- Sets the initial URL loaded when IE starts. This is intended to be used with {@link #ignoreProtectedModeSettings} to allow the user to initialize IE in the proper Protected Mode zone. Setting this option may cause browser instability or flaky and unresponsive code. Only 'best effort' support is provided when using this option.

  #### Parameters

  - ##### url: string

    The initial browser URL.

  #### Returns <internal>.Options

  A self reference.

### introduceFlakinessByIgnoringProtectedModeSettings

- introduceFlakinessByIgnoringProtectedModeSettings(ignoreSettings: boolean): <internal>.Options

- Whether to disable the protected mode settings check when the session is created. Disbling this setting may lead to significant instability as the browser may become unresponsive/hang. Only 'best effort' support is provided when using this capability.

  For more information, refer to the IEDriver's required system configuration.

  #### Parameters

  - ##### ignoreSettings: boolean

    Whether to ignore protected mode settings.

  #### Returns <internal>.Options

  A self reference.

### keys

- keys(): IterableIterator<string>

- Inherited from Capabilities.keys

  #### Returns IterableIterator<string>

  an iterator of the keys set.

### merge

- merge(other: {} | Capabilities | Map<string, any>): Capabilities

- Inherited from Capabilities.merge

  Merges another set of capabilities into this instance.

  #### Parameters

  - ##### other: {} | Capabilities | Map<string, any>

    The other set of capabilities to merge.

  #### Returns Capabilities

  A self reference.

### requireWindowFocus

- requireWindowFocus(require: boolean): <internal>.Options

- Configures whether to require the IE window to have input focus before performing any user interactions (i.e. mouse or keyboard events). This option is disabled by default, but delivers much more accurate interaction events when enabled.

  #### Parameters

  - ##### require: boolean

    Whether to require window focus.

  #### Returns <internal>.Options

  A self reference.

### set

- set(key: string, value: any): Capabilities

- Inherited from Capabilities.set

  throws

    {TypeError} If the `key` is not a string.

  #### Parameters

  - ##### key: string

    The capability key.

  - ##### value: any

    The capability value.

  #### Returns Capabilities

  A self reference.

### setAcceptInsecureCerts

- setAcceptInsecureCerts(accept: boolean): Capabilities

- Inherited from Capabilities.setAcceptInsecureCerts

  Sets whether a WebDriver session should implicitly accept self-signed, or other untrusted TLS certificates on navigation.

  #### Parameters

  - ##### accept: boolean

    whether to accept insecure certs.

  #### Returns Capabilities

  a self reference.

### setAlertBehavior

- setAlertBehavior(behavior: string): Capabilities

- Inherited from Capabilities.setAlertBehavior

  Sets the default action to take with an unexpected alert before returning an error. If unspecified, WebDriver will default to {@link UserPromptHandler.DISMISS_AND_NOTIFY}.

  #### Parameters

  - ##### behavior: string

    The way WebDriver should respond to unhandled user prompts.

  #### Returns Capabilities

  A self reference.

### setBrowserName

- setBrowserName(name: string): Capabilities

- Inherited from Capabilities.setBrowserName

  Sets the name of the target browser.

  #### Parameters

  - ##### name: string

    the browser name.

  #### Returns Capabilities

  a self reference.

### setBrowserVersion

- setBrowserVersion(version: string): Capabilities

- Inherited from Capabilities.setBrowserVersion

  Sets the desired version of the target browser.

  #### Parameters

  - ##### version: string

    the desired version.

  #### Returns Capabilities

  a self reference.

### setExtractPath

- setExtractPath(path: string): <internal>.Options

- Sets the path of the temporary data directory to use.

  #### Parameters

  - ##### path: string

    The log file path.

  #### Returns <internal>.Options

  A self reference.

### setHost

- setHost(host: string): <internal>.Options

- Sets the IP address of the driver's host adapter.

  #### Parameters

  - ##### host: string

    The IP address to use.

  #### Returns <internal>.Options

  A self reference.

### setLogFile

- setLogFile(file: string): <internal>.Options

- Sets the path to the log file the driver should log to.

  #### Parameters

  - ##### file: string

    The log file path.

  #### Returns <internal>.Options

  A self reference.

### setLogLevel

- setLogLevel(level: <internal>.Level): <internal>.Options

- Sets the IEDriverServer's logging level.

  #### Parameters

  - ##### level: <internal>.Level

    The logging level.

  #### Returns <internal>.Options

  A self reference.

### setLoggingPrefs

- setLoggingPrefs(prefs: {} | Preferences): Capabilities

- Inherited from Capabilities.setLoggingPrefs

  Sets the logging preferences. Preferences may be specified as a {@link ./logging.Preferences} instance, or as a map of log-type to log-level.

  #### Parameters

  - ##### prefs: {} | Preferences

    The logging preferences.

  #### Returns Capabilities

  A self reference.

### setPageLoadStrategy

- setPageLoadStrategy(strategy: string): Capabilities

- Inherited from Capabilities.setPageLoadStrategy

  Sets the desired page loading strategy for a new WebDriver session.

  #### Parameters

  - ##### strategy: string

    the desired strategy.

  #### Returns Capabilities

  a self reference.

### setPlatform

- setPlatform(platform: string): Capabilities

- Inherited from Capabilities.setPlatform

  Sets the target platform.

  #### Parameters

  - ##### platform: string

    the target platform.

  #### Returns Capabilities

  a self reference.

### setProxy

- setProxy(proxy: ProxyConfig): <internal>.Options

- Overrides Capabilities.setProxy

  Sets the proxy settings for the new session.

  #### Parameters

  - ##### proxy: ProxyConfig

    The proxy configuration to use.

  #### Returns <internal>.Options

  A self reference.

### silent

- silent(silent: boolean): <internal>.Options

- Sets whether the driver should start in silent mode.

  #### Parameters

  - ##### silent: boolean

    Whether to run in silent mode.

  #### Returns <internal>.Options

  A self reference.

### usePerProcessProxy

- usePerProcessProxy(enable: boolean): <internal>.Options

- Configures whether proxies should be configured on a per-process basis. If not set, setting a {@linkplain #setProxy proxy} will configure the system proxy. The default behavior is to use the system proxy.

  #### Parameters

  - ##### enable: boolean

    Whether to enable per-process proxy settings.

  #### Returns <internal>.Options

  A self reference.

### Static chrome

- chrome(): Capabilities

- Inherited from Capabilities.chrome

  #### Returns Capabilities

  A basic set of capabilities for Chrome.

### Static edge

- edge(): Capabilities

- Inherited from Capabilities.edge

  #### Returns Capabilities

  A basic set of capabilities for Microsoft Edge.

### Static firefox

- firefox(): Capabilities

- Inherited from Capabilities.firefox

  #### Returns Capabilities

  A basic set of capabilities for Firefox.

### Static ie

- ie(): Capabilities

- Inherited from Capabilities.ie

  #### Returns Capabilities

  A basic set of capabilities for Internet Explorer.

### Static safari

- safari(): Capabilities

- Inherited from Capabilities.safari

  #### Returns Capabilities

  A basic set of capabilities for Safari.

Generated using TypeDoc